using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.ComponentModel;

namespace Dah.Windows.Forms
{
    /// <summary>
    /// ûıʱʾˮӡı
    /// </summary>
    public class WatermarkTextBox : TextBox
    {
        private string _watermarkText = "Input Here";
        private Color _watermarkColor = Color.FromArgb(150, 150, 150);
        private Color _normalTextColor = Color.Black;
        private bool _treatBlankAsInputText = false;

        /// <summary>
        /// ȡıʱıɫ
        /// </summary>
        [Category("WatermarkTextBox")]
        [Description("ȡıʱıɫ")]
        public Color NormalTextColor
        {
            get { return _normalTextColor; }
            set { _normalTextColor = value; }
        }

        /// <summary>
        /// ȡˮӡıɫ
        /// </summary>
        [Category("WatermarkTextBox")]
        [Description("ȡˮӡıɫ")]
        public Color WatermarkColor
        {
            get { return _watermarkColor; }
            set { _watermarkColor = value; }
        }

        /// <summary>
        /// ȡˮӡı
        /// </summary>
        [Category("WatermarkTextBox")]
        [DefaultValue("Input Here")]
        [Description("ȡˮӡı")]
        [Editor]
        public string WatermarkText
        {
            get { return _watermarkText; }
            set 
            {
                _watermarkText = value;
                if (HasWatermark)
                {
                    this.Text = _watermarkText;
                }
            }
        }

        /// <summary>
        /// ȡǷӿոΪı
        /// </summary>
        [Category("WatermarkTextBox")]
        [DefaultValue(false)]
        [Description("ȡǷӿոΪı")]
        public bool TreatBlankAsInputText
        {
            get { return _treatBlankAsInputText; }
            set { _treatBlankAsInputText = value; }
        }

        #region Hide Some Base Type's Property

        [Browsable(false)]
        public new Color ForeColor
        {
            get { return base.ForeColor; }
            set { base.ForeColor = value; }
        }

        [Browsable(false)]
        public new string Text
        {
            get { return base.Text; }
            set { base.Text = value; }
        }

        #endregion

        /// <summary>
        /// ȡǷı
        /// </summary>
        public bool HasInputText
        {
            get
            {
                if (_treatBlankAsInputText)
                {
                    return this.Text != "";
                }
                else
                {
                    return this.Text.Trim() != "";
                }
            }
        }

        /// <summary>
        /// ȡǷˮӡ״̬
        /// </summary>
        public bool HasWatermark
        {
            get
            {
                return this.Text == _watermarkText;
            }
        }

        protected override void OnCreateControl()
        {
            base.OnCreateControl();
            ShowWaterMark();
        }

        protected override void OnGotFocus(EventArgs e)
        {
            base.OnGotFocus(e);
            if (HasWatermark)
            {
                HideWaterMark();
            }
        }

        protected override void OnLostFocus(EventArgs e)
        {
            base.OnLostFocus(e);
            if (!HasInputText)
            {
                ShowWaterMark();
            }
        }

        private void HideWaterMark()
        {
            this.ForeColor = _normalTextColor;
            this.Text = "";
        }

        private void ShowWaterMark()
        {
            this.ForeColor = _watermarkColor;
            this.Text = _watermarkText;
        }
    }
}
